import java.util.ArrayList;

/**
 * DarkRoom: if you don't have the flashlight,
 * you can't do anything except exit via the exitdir.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DarkRoom extends Room
{
    // instance variables - replace the example below with your own
    private String exitdir;
    private ArrayList inventory;

    /**
     * Constructor for objects of class ZooRoom
     */
    public DarkRoom(String exitdir, String desc, ArrayList inv)
    {
        super(desc);
        this.exitdir = exitdir;
        inventory = inv;
    }

    /**
     * getShortDescription prints the dark description if there is no light.
     */
    public String getShortDescription() {
        if (Light.haslight(inventory)) 
            return super.getShortDescription();
        String desc = "in a pitch-dark place! You need a light!";
        return desc;
    }
    
    public String getLongDescription() {
        if (Light.haslight(inventory))
            return super.getLongDescription();
        String desc1 = getShortDescription();
        String desc2 = "The only way out you can see is a dimly lit exit to the " + exitdir;
        return desc1 + "\n" + desc2;
    }

    /**

     * respond: right now it only responds to LIGHT FLASHLIGHT.
     * Arguably that should be moved to elsewhere.
     * 
     */
    public void respond(Command c, ArrayList inventory) {
        String commandWord = c.getCommandWord();
        String object = c.getSecondWord();
        if (commandWord.equals("light")) {
            if (object.equals("flashlight")) {
                Item f = Game.findByName("flashlight", inventory);
                if (f == null) {
                    System.out.println("you don't have the flashlight");
                    return;
                }
                if (f instanceof Light) { // It had better be!
                    Light fl = (Light) f;
                    fl.light();
                    System.out.println("The light is now on");
                    System.out.println(getLongDescription());
                } else {
                    System.out.println("Couldn't light the flashlight! Maybe it's broken!");
                }
            } else {
                System.out.println("You can't light that!");
            }
        } else if (commandWord.equals("take")) {
            super.respond(c, inventory);
        } else {
            super.respond(c, inventory);
        }
    }
    
    /**
     * getExit: only allows going out the exitdir if we don't have the light.
     * Note that this is NOT necessarily the same as the way we came in!
     * What would it take to implement the latter?
     */
    public Room getExit(String direction) 
    {
        if (Light.haslight(inventory) || direction.equals(exitdir)) {
            return super.getExit(direction);
        } else {
            System.out.println("It's too dark to see any exit that way!");
            return null;
        }
    }
    
}
